var bGLGToolbarQuestionAsked = false;

// Every time a new browser window is made GLGOverlayInit will be called
window.addEventListener("load",GLGOverlayInit,true);
window.addEventListener("unload",GLGOverlayDeInit,false);

function GLGOverlayInit()
{
	//Init Utils.
	var oUtils = new GLGUtils();
	bReceivedGLGOpenedMessage = false;

	if (bGLGToolbarQuestionAsked == false)
	{
		bGLGToolbarQuestionAsked = true;

		this.GLGObserver =
		{
			observe: function(subject, topic, state)
			{
				if (topic == "glg-notifyopened" && state == 'OK') {bReceivedGLGOpenedMessage = true;}
			}
		}

		//Check if the user wants to automaticly add the toolbar button.
		if (!oUtils.CheckPreferenceUserValue("checkaddtoolbarbutton")) oUtils.SetPreferenceBool("checkaddtoolbarbutton", true);

		var oNavBar = document.getElementById("nav-bar");
		if (oNavBar && oNavBar.currentSet)
		{
			var bCheck = oUtils.GetPreferenceBool("checkaddtoolbarbutton") && (!document.getElementById("tbtnCavemanGLG"));
			
			if (bCheck)
			{
				var checkResult = {};
				var bAddButton = oUtils.oPromptService.confirmCheck(window,oUtils.GetString('glg-toolbar-msg-title'), oUtils.GetString('glg-toolbar-msg-question'), oUtils.GetString('glg-toolbar-msg-showonce'), checkResult);

				if (checkResult.value) bCheck = false;
				
				if (bAddButton == true)
				{
					var sNewSet = oNavBar.currentSet + ",tbtnCavemanGLG";
					oNavBar.currentSet = sNewSet;
					oNavBar.setAttribute("currentset", sNewSet );
					document.persist("nav-bar", "currentset");
					oUtils.oPromptService.alert(window, oUtils.GetString('glg-toolbar-msg-title'), oUtils.GetString('glg-toolbar-msg-info'));
					BrowserShutdown(); //Fails execution in Ff Pre deer park, but that's ok. Works now on both versions...
					OpenBrowserWindow();
				}
				oUtils.SetPreferenceBool("checkaddtoolbarbutton", bCheck);
			}
		}
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
		oObService.addObserver(this.GLGObserver, "glg-notifyopened", false);

		window.addEventListener("GLGAddRecipeEvent", GLGAddRecipeListener, false, true);
	}
}

function GLGOverlayDeInit()
{
	try
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
		oObService.removeObserver(this.GLGObserver, "glg-notifyopened");
	} catch (e) {}
	this.GLGObserver = null;
}

function RestoreDefaultDatabase()
{
	var oUtils = new GLGUtils();
	if (oUtils.GLGQuestion('glg-application-msg-restoredefaultdata') == true)
	{
		var oDishesFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var oItemsFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

		if (!oUtils.CheckPreferenceUserValue("datadir")) oUtils.SetPreferenceString("datadir", "");
		var sDataDirectory = oUtils.GetPreferenceString("datadir");
		if (sDataDirectory == "") sDataDirectory = oUtils.GetDataDirectory();		

		oDishesFile.initWithPath(sDataDirectory);
		oDishesFile.append('glg_dishes.dat');
		if (oDishesFile.exists()) oDishesFile.remove(false);

		oItemsFile.initWithPath(sDataDirectory);
		oItemsFile.append('glg_items.dat');
		if (oItemsFile.exists()) oItemsFile.remove(false);
		
		oUtils.SetPreferenceBool("version10data", true);
		oUtils.SetPreferenceBool("version13data", true);
		oUtils.SetPreferenceBool("version15data", true);
	}
}

function OpenGLG(oEvent)
{
	if (oEvent && oEvent.shiftKey == true && oEvent.ctrlKey == true) RestoreDefaultDatabase();
	
	var oUtils = new GLGUtils();
	var oGLGWin;
	var iTop, iLeft;
	var iWidth, iHeight;
	
	//Only open it once.
	oGLGWin = oUtils.FindWindow('glg-window');
	if (!oGLGWin)
	{
		bReceivedGLGOpenedMessage = false;
		window.open("chrome://glg/content/glg.xul", "glg-window", "chrome,resizable=yes");
	}
	else
	{
		oGLGWin.center(null, true, true);
		if (!document.getElementById('key_stop_mac'))
		{
			//For some reason this crashes on a Mac...
			oGLGWin.zLevel = oGLGWin.raisedZ; //Kick to foreground.
			oGLGWin.zLevel = oGLGWin.normalZ; //Set normal Z-order again.
		}
		bReceivedGLGOpenedMessage = true;
	}
}

function GLGAddRecipeListener(oEvent)
{
	var oUtils = new GLGUtils();
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var oItem;
	var sLabel, sSource;
	
	sLabel = oEvent.target.getAttribute("glglabel");
	sSource = oUtils.GetDomainFromURI(content.location.href);
	var bConfirm = oUtils.GLGQuestion('glg-application-msg-addwebrecipe', sLabel, sSource);
	if (bConfirm)
	{
		OpenGLG();
		this.sWebsiteRecipe = sLabel;
		this.sWebsiteGLGDish = oEvent.target.getAttribute("glgdish");
		this.sWebsiteGLGItems = oEvent.target.getAttribute("glgitems");
		setTimeout("NotifyGLGAddWebRecipe();", 500);
	}
}

function NotifyGLGAddWebRecipe()
{
	if (bReceivedGLGOpenedMessage)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(this, "glg-addwebrecipe", "OK");
	}
	else {setTimeout("NotifyGLGAddWebRecipe();", 500);}
}
