function InitWindow()
{
	var oParams = window.arguments[0];

	this.oUtils = new GLGUtils();
	this.bIsTyping = false;
	this.aItems = oParams.items;
	this.aItems.sort(ArrayCompareItemName);
	this.aItemTypes = this.oUtils.GetLocalizedPref("typeorder").split("#");
	
	document.title = this.oUtils.GetString("glg-additem-name");
	InitList('');
	InitItemTypes();
}

function InitList(sFilter)
{
	var oList = document.getElementById('glg-allitems');
	var iIndex, iLen = this.aItems.length;
	var oFirst = null;
	
	RemoveAllChildren(oList);
	if (sFilter) sFilter = sFilter.toLowerCase();
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (!sFilter || sFilter == '' || this.aItems[iIndex][2].toLowerCase().indexOf(sFilter) >= 0)
		{
			if (!oFirst) oFirst = oList.appendItem(this.aItems[iIndex][2], this.aItems[iIndex][0]);
			else oList.appendItem(this.aItems[iIndex][2], this.aItems[iIndex][0]);
		}
	}
	if (oFirst) oList.selectItem(oFirst);
}

function InitItemTypes()
{
	var oMenu = document.getElementById('itemtype');
	var iIndex, iLen = this.aItemTypes.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oMenu.appendItem(this.aItemTypes[iIndex]);
	}
    if (!oMenu.label || oMenu.label == "") oMenu.selectedIndex = 0;
}

function ApplyAndClose()
{
	var oParams = window.arguments[0];
	
	var oList = document.getElementById('glg-allitems');
	if (oList.selectedItem)
	{
		var iIIndex;
		iIIndex = GetItemIndex(oList.selectedItem.label);
		if (iIIndex >= 0)
		{
			oParams.isnewitem = false;
			oParams.id = this.aItems[iIIndex][0];
		}

	}

	oParams.name = document.getElementById('itemname').value;
	oParams.type = document.getElementById('itemtype').label;
	if (parseInt(document.getElementById('itemnoitems').value) > 0) oParams.noitems = parseInt(document.getElementById('itemnoitems').value);
	oParams.quantity = document.getElementById('itemquantity').value;
	oParams.accepted = true;
	window.close();
}

function PreSelectItem()
{
	setTimeout('SelectItem();', 50);
}

function SelectItem()
{
	var oList = document.getElementById('glg-allitems');
	if (!this.bIsTyping && oList.selectedItem)
	{
		var iIIndex = GetItemIndex(oList.selectedItem.label);
		if (iIIndex >= 0)
		{
			document.getElementById('itemname').value = this.aItems[iIIndex][2];
			var iTIndex = GetItemTypeIndex(this.aItems[iIIndex][1]);
			if (iTIndex >= 0)
			{
				var oMenu = document.getElementById('itemtype');
				oMenu.selectedIndex = iTIndex;
			}
		}
	}
}

function ItemFocusChange(oItem, bGotFocus)
{
	if (bGotFocus) oItem.select();
	this.bIsTyping = bGotFocus;
}

function HandleKeyUp()
{
	InitList(document.getElementById('itemname').value);
}

function RemoveAllChildren(oItem)
{
	var iIndex, iLen = oItem.childNodes.length - 1;
	for (iIndex = iLen; iIndex >= 0; iIndex --)
	{
		oItem.removeChild(oItem.childNodes[iIndex]);
	}
}

function GetItemIndex(sLabel)
{
	var iIndex, iLen = this.aItems.length;
	
	for (iIndex = 0; iIndex < iLen; iIndex ++) if (this.aItems[iIndex][2] == sLabel) return iIndex;
	return -1;
}

function GetItemTypeIndex(sLabel)
{
	var iIndex, iLen = this.aItemTypes.length;
	
	for (iIndex = 0; iIndex < iLen; iIndex ++) if (this.aItemTypes[iIndex] == sLabel) return iIndex;
	return -1;
}

function ArrayCompareItemName(a1, a2)
{
	if (a1[2] < a2[2]) return -1;
	return 1;
}

