function InitWindow()
{
	this.GLGListObserver =
	{
		observe: function(subject, topic, state)
		{
			if (topic == "glg-populate" && state == 'OK') if (typeof(PopulateWindow)=="function") PopulateWindow(subject.wrappedJSObject);
			if (topic == "glg-close" && state == 'OK') if (window) window.close();
		}
	}

	this.sToolbarMode = "";
	this.sToolbarIconSize = "";
	this.sPublishRecipeHTML = "";
	this.sRecipe = "";
	this.sGLGDish = "";
	this.sGLGItems = "";
	
	this.bIsRecipe = false;
	this.bHasComment = false;
	this.bhasIngredients = false;

	//Init observer.
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
	oObService.addObserver(this.GLGListObserver, "glg-populate", false);
	oObService.addObserver(this.GLGListObserver, "glg-close", false);

	//Init Utils.
	this.oUtils = new GLGUtils();

	//Init toolbar
	this.sToolbarMode = this.oUtils.GetPreferenceString("toolbarmode");
	this.sToolbarIconSize = this.oUtils.GetPreferenceString("toolbariconsize");

	SetToolbarMode(this.sToolbarMode);
	SetToolbarIconSize(this.sToolbarIconSize);
	InitToolbar();

	document.title = this.oUtils.GetString("glglist-name");

	InitFrame();
}

function CloseWindow()
{
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
	oObService.removeObserver(this.GLGListObserver, "glg-populate");
	oObService.removeObserver(this.GLGListObserver, "glg-close");
	this.GLGListObserver = null;
}

function InitFrame()
{
	var oDocument = document.getElementById('frame_list').contentDocument;
	var oBody = oDocument.getElementsByTagName('body')[0];
	var oHead = oDocument.getElementsByTagName('head')[0];
	var dToday = new Date();
	var sToday = this.oUtils.GetString("glg-days-" + dToday.getDay()) + " " + dToday.getDate() + " " + this.oUtils.GetString("glg-months-" + dToday.getMonth()) + " " + dToday.getFullYear();
	var sTitle = this.oUtils.GetString("glglist-caption", sToday);

	oDocument.title = sTitle;
	oHead.innerHTML = "<meta http-equiv='content-type' content='text/html; charset=UTF-8'><title>" + sTitle + "</title>";

	var oStyle = oDocument.createElement('style');
	oStyle.type = 'text/css';
	oStyle.innerHTML = 'body, p, span, table, td {font: 9pt verdana; background-color: white;} p {margin: 7 0 7 0} ul {list-style-type: none; list-style-position: outside; list-style-image: url("chrome://glg/skin/glg_bullet.png");} .glglisttype {font-weight: bold; padding-top: 10px} .glglistitem, .directions {margin-left: 22px;} .directions {margin-right: 60px;} .glglistfooter {white-space: nowrap; text-align: center; width: 95%;} .glglistlogo-l {margin-right: 5px;} .glglistlogo-r {margin-left: 5px;} .glgrecipedish {font-weight: bold; font-size: 11pt;} .glglistlabel {font-weight: bold; margin-left: 10px; border-top: dashed 1px rgb(239,5,127); padding-bottom: 5px; padding-top: 5px;} .glgrecipecomment, .glgrecipequantity {font-style: italic} .glgnoitems {width: 30px; text-align: right; padding-right: 10px} .glgleftcell {padding-right: 20px} td {vertical-align: top} .glglist {margin-bottom: 40px; width: 100%} .recipephoto {max-width: 200px; max-height: 200px; margin-right: 60px; border: solid 1px rgb(239,5,127); margin-top: 8px;} .ingredients td {vertical-align: top;}';
	oHead.appendChild(oStyle);

	var oHeader = oDocument.createElement('p');
	oHeader.className = 'glglistheader';
	oHeader.id = "glgheader";
	oHeader.innerHTML = sTitle;
	oBody.appendChild(oHeader);
}

function PopulateWindow(aList)
{
	var oDocument = document.getElementById('frame_list').contentDocument;
	var oBody = oDocument.getElementsByTagName('body')[0];
	var oCredits = oDocument.createElement('table');
	var iHeight;
	if (typeof(aList[0][1]) == "object")
	{
		this.bIsRecipe = false;
		PopulateListWindow(aList);
		var sCredits = this.oUtils.GetString("glglist-credits");
	}
	else
	{
		this.bIsRecipe = true;
		PopulateRecipeWindow(aList);
		var sCredits = this.oUtils.GetString("glgrecipe-credits");
	}
	document.getElementById('tbpublish').setAttribute('hidden', !this.bIsRecipe);

	iHeight = oBody.scrollHeight - 50;
    oCredits.className = 'glglistfooter';
    oCredits.id = 'glgfooter';
    oCredits.innerHTML = "<tr><td><image class='glglistlogo-l' src='chrome://glg/skin/glg_toolbar_small.png' alt='" + sCredits + "'>" + sCredits + "<image class='glglistlogo-r' src='chrome://glg/skin/glg_toolbar_small.png' alt='" + sCredits + "'></td></tr>";
    oCredits = oBody.appendChild(oCredits);

	var oWindow = document.getElementById('glglist-window').boxObject;
	window.resizeTo(710, oWindow.height);
}

function PopulateListWindow(aList)
{
	var oDocument = document.getElementById('frame_list').contentDocument;
	var oBody = oDocument.getElementsByTagName('body')[0];
	var oTable, oRow, oCell1, oCell2, oCurrentCell;
	var oSubTable, oSubRow, oSubCell;
	var iRows, iRow;
    var iTIndex, iTLen;
	var iIIndex, iIlen;
	var iItemsDone = 0, iTotalItems = 0;
	var iMoveToNextCellEarly = 0;
	var iStoredRow = 0;
	var bMoveToNextCellEarly = false;

	oTable = oDocument.createElement('table');
	oTable.className = "glglist";
	oBody.appendChild(oTable);

	//Determine the number of table rows we need, including item type headers.
	iTLen = aList.length;
	for (iTIndex = 0; iTIndex < iTLen; iTIndex ++)
    {
		iTotalItems ++;
		iILen = aList[iTIndex][1].length;
		for (iIIndex = 0; iIIndex < iILen; iIIndex ++)
		{
			iTotalItems ++;
		}
	}
	iRows = Math.ceil(iTotalItems / 2);
	if (!this.oUtils.GetPreferenceBool("use2columnlist")) iRows = iTotalItems;
	
	iRow = 0;
	
	iTLen = aList.length;
	for (iTIndex = 0; iTIndex < iTLen; iTIndex ++)
	{
		if (iItemsDone <= iRows)
		{
			oRow = oDocument.createElement('tr');
			oRow.id = "tr_" + iRow;
			oCell1 = oDocument.createElement('td');
			oCell1.id = "td_1_" + iRow;
			oCell1.className = "glgleftcell";
			oCell2 = oDocument.createElement('td');
			oCell1.className = "glgrightcell";
			oCell2.id = "td_2_" + iRow;
			
			oRow.appendChild(oCell1);
			oRow.appendChild(oCell2);
			oTable.appendChild(oRow);
			
			oCurrentCell = oCell1;
			//Check if we want the next category on the right column so we can start with the header there.
			if (!bMoveToNextCellEarly)
			{
				iMoveToNextCellEarly = iItemsDone + aList[iTIndex][1].length + 1 - iRows;
				if (iMoveToNextCellEarly > 0)
				{
					iRows = iRows + aList[iTIndex][1].length + 1;
					iItemsDone = iRows + 1;
					iStoredRow = iRow + 1;
					for (iRow = iStoredRow; iRow < iRows + 1; iRow ++)
					{
						oRow = oDocument.createElement('tr');
						oRow.id = "tr_" + iRow;
						oCell1 = oDocument.createElement('td');
						oCell1.id = "td_1_" + iRow;
						oCell1.className = "glgleftcell";
						oCell2 = oDocument.createElement('td');
						oCell2.id = "td_2_" + iRow;
						
						oRow.appendChild(oCell1);
						oRow.appendChild(oCell2);
						oTable.appendChild(oRow);
					}
					iRow = 0;
					oRow = oDocument.getElementById("tr_" + iRow);
					oCell1 = oDocument.getElementById("td_1_" + iRow);
					oCell2 = oDocument.getElementById("td_2_" + iRow);
					bMoveToNextCellEarly = true;
				}
			}
		}
		else
		{
			oRow = oDocument.getElementById("tr_" + iRow);
			oCell1 = oDocument.getElementById("td_1_" + iRow);
			oCell2 = oDocument.getElementById("td_2_" + iRow);
			oCurrentCell = oCell2;
		}
		if (bMoveToNextCellEarly == true)
		{
			oCurrentCell = oCell2;
		}
		oCurrentCell.className = "glglisttype";
		oCurrentCell.innerHTML = aList[iTIndex][0];

		iItemsDone ++;
		iRow ++;
		if (iRow > iRows) iRow = 0;

		iILen = aList[iTIndex][1].length;
		for (iIIndex = 0; iIIndex < iILen; iIIndex ++)
		{
			if (iItemsDone <= iRows)
			{
				oRow = oDocument.createElement('tr');
				oRow.id = "tr_" + iRow;
				oCell1 = oDocument.createElement('td');
				oCell1.id = "td_1_" + iRow;
				oCell1.className = "glgleftcell";
				oCell2 = oDocument.createElement('td');
				oCell2.id = "td_2_" + iRow;
				
				oRow.appendChild(oCell1);
				oRow.appendChild(oCell2);
				oTable.appendChild(oRow);
				
				oCurrentCell = oCell1;
			}
			else
			{
				oRow = oDocument.getElementById("tr_" + iRow);
				oCell1 = oDocument.getElementById("td_1_" + iRow);
				oCell2 = oDocument.getElementById("td_2_" + iRow);
				oCurrentCell = oCell2;
			}
			if (bMoveToNextCellEarly == true)
			{
				oCurrentCell = oCell2;
			}
		
			oSubTable = oDocument.createElement('table');

			oSubRow = oDocument.createElement('tr');
			oSubRow.className = "glglistitem";
			oSubCell = oDocument.createElement('td');
			oSubCell.className = "glgnoitems";
			oSubCell.innerHTML = aList[iTIndex][1][iIIndex][1];
			oSubRow.appendChild(oSubCell);

			oSubCell = oDocument.createElement('td');
			oSubCell.innerHTML = aList[iTIndex][1][iIIndex][0];
			oSubRow.appendChild(oSubCell);
			
			oSubTable.appendChild(oSubRow);
			
			if (this.oUtils.GetPreferenceBool("includecommentsinlist") == true)
			{
				if (aList[iTIndex][1][iIIndex][2] && aList[iTIndex][1][iIIndex][2] != "")
				{
				
					oSubRow = oDocument.createElement('tr');
					oSubCell = oDocument.createElement('td');
					oSubRow.appendChild(oSubCell);
					oSubCell = oDocument.createElement('td');
					oSubCell.className = "glgrecipecomment";
					oSubCell.innerHTML = aList[iTIndex][1][iIIndex][2];
					oSubRow.appendChild(oSubCell);
					oSubTable.appendChild(oSubRow);
				}
			}
			if (this.oUtils.GetPreferenceBool("includequantityinlist") == true)
			{
				if (aList[iTIndex][1][iIIndex][3] && aList[iTIndex][1][iIIndex][3] != "")
				{
				
					oSubRow = oDocument.createElement('tr');
					oSubCell = oDocument.createElement('td');
					oSubRow.appendChild(oSubCell);
					oSubCell = oDocument.createElement('td');
					oSubCell.className = "glgrecipequantity";
					oSubCell.innerHTML = aList[iTIndex][1][iIIndex][3];
					oSubRow.appendChild(oSubCell);
					oSubTable.appendChild(oSubRow);
				}
			}
			
			oCurrentCell.appendChild(oSubTable);

			iItemsDone ++;
			iRow ++;
			if (iRow > iRows) iRow = 0;
		}
	}
}

function PopulateRecipeWindow(aList)
{
	var oDocument = document.getElementById('frame_list').contentDocument;
	var oBody = oDocument.getElementsByTagName('body')[0];
	var aComment = new Array();
	var dToday = new Date();
	var sToday = this.oUtils.GetString("glg-days-" + dToday.getDay()) + " " + dToday.getDate() + " " + this.oUtils.GetString("glg-months-" + dToday.getMonth()) + " " + dToday.getFullYear();
	var sTitle = aList[0][0] + " " + this.oUtils.GetString("glgrecipe-caption", sToday);
	var sHTML, sIngredientsHTML = "";
	var oItem, oItem2;
	var iIIndex, iILen;
	var iCIndex, iCLen;

	document.title = sTitle;
	oDocument.title = sTitle;
	oDocument.getElementsByTagName('title')[0].childNodes[0].nodeValue = sTitle;
	oDocument.getElementById('glgheader').innerHTML = sTitle;

	this.sRecipe = aList[0][0];
	this.sGLGDish = aList[2];
	this.sGLGItems = aList[3];

	oItem = oDocument.createElement('p');
	oItem.className = "glgrecipedish";
	oItem.innerHTML = aList[0][0];
	this.sPublishRecipeHTML += this.oUtils.Node2XML(oItem);
	oBody.appendChild(oItem);
	oItem = oDocument.createElement('p');

	iILen = aList[1].length;
	for (iIIndex = 0; iIIndex < iILen; iIIndex ++)
	{
		if (aList[1][iIIndex][3] && aList[1][iIIndex][3] != "")
		{
			sIngredientsHTML += "<li>" + aList[1][iIIndex][0] + ", " + aList[1][iIIndex][3] + "</li>"
		}
	}

	sHTML = aList[0][1].replace(/\n/g, '<br/>');
/*	aComment = sHTML.split('*');
	iCLen = aComment.length;
	if (iCLen >= 3)
	{
		sHTML = "<ul class='directions'>";
		for (iCIndex = 0; iCIndex < iCLen; iCIndex ++)
		{
			if (aComment[iCIndex] != "") sHTML += "<li>" + aComment[iCIndex] + "</li>";
		}
		sHTML += "</ul>";
	}
	else
	{
		aComment = sHTML.split('\n');
		iCLen = aComment.length;
		if (iCLen >= 3)
		{
			sHTML = "<ul class='directions'>";
			for (iCIndex = 0; iCIndex < iCLen; iCIndex ++)
			{
				if (aComment[iCIndex] != "") sHTML += "<li>" + aComment[iCIndex] + "</li>";
			}
			sHTML += "</ul>";
		}	
	}
*/	
	sHTML += "<p class='glglistlabel'>" + this.oUtils.GetString("glgrecipe-grocerylist") + "</p>";
	sHTML = "<p class='glglistlabel'>" + this.oUtils.GetString("glgrecipe-directions") + "</p><p class='directions'>" + sHTML + "</p>";
	if (sIngredientsHTML != "")
	{
		this.bhasIngredients = true;
		sHTML = "<table width='100%' class='ingredients'><tr><td><p class='glglistlabel glgfirstlistlabel'>" + this.oUtils.GetString("glgrecipe-ingredients") + "</p></td><td rowspan='2' align='right'><img class='recipephoto' src='" + aList[0][2] + "'/></td></tr><tr><td><ul>" + sIngredientsHTML + "</ul></td></tr></table>" + sHTML;
	}
	else
	{
		sHTML = "<table width='100%' class='ingredients'><tr><td><p class='glglistlabel glgfirstlistlabel'>" + this.oUtils.GetString("glgrecipe-ingredients") + "</p></td><td rowspan='2' align='right'><img class='recipephoto' src='" + aList[0][2] + "'/></td></tr><tr><td></td></tr></table>" + sHTML;
	}
//	sHTML = "<p class='glglistlabel glgfirstlistlabel'>" + this.oUtils.GetString("glgrecipe-ingredients") + "</p>" + sHTML;
	oItem.innerHTML = sHTML;
	if (aList[0][1].length > 250) this.bHasComment = true;
	this.sPublishRecipeHTML += this.oUtils.Node2XML(oItem);
	oBody.appendChild(oItem);

	iILen = aList[1].length;
	for (iIIndex = 0; iIIndex < iILen; iIIndex ++)
	{
		oItem = oDocument.createElement('p');
		oItem.className = "glglistitem";
		oItem.innerHTML = aList[1][iIIndex][2];

		oItem2 = oDocument.createElement('span');
		oItem2.style.marginLeft = 1.4 - (parseInt(aList[1][iIIndex][2].toString().length) * 0.6) + "em";
		oItem2.innerHTML = aList[1][iIIndex][0];

		oItem.appendChild(oItem2);
		this.sPublishRecipeHTML += this.oUtils.Node2XML(oItem);
		oBody.appendChild(oItem);

		if (aList[1][iIIndex][1] && aList[1][iIIndex][1] != "")
		{
			oItem = oDocument.createElement('p');
			oItem.className = "glglistitem";
			oItem.innerHTML = Space(aList[1][iIIndex][2].toString().length);

			oItem2 = oDocument.createElement('span');
			oItem2.className = "glgrecipecomment";
			oItem2.style.marginLeft = 1.4 - (parseInt(aList[1][iIIndex][2].toString().length) * 0.6) + "em";
			oItem2.innerHTML = aList[1][iIIndex][1];

			oItem.appendChild(oItem2);
			this.sPublishRecipeHTML += this.oUtils.Node2XML(oItem);
			oBody.appendChild(oItem);
		}
	}
	//Add margin to the last item.
	oItem.setAttribute('style', 'margin-bottom: 40px');
}

function PublishRecipe()
{
	if (!this.bHasComment) return this.oUtils.GLGError("glg-application-msg-enterrecipe");
	if (!this.bhasIngredients) return this.oUtils.GLGError("glg-application-msg-enteringredients");
	if (this.oUtils.GLGQuestion('glg-application-msg-publish'))
	{
		var sUserID = this.oUtils.GetPreferenceString("glgwebuserid");
		var sCreator = this.oUtils.GetPreferenceString("glgwebnickname")
		if (!sCreator || sCreator == "") sCreator = this.oUtils.GLGPromptQuestion(this.oUtils.GetString("glg-application-msg-publish-nickname"), this.oUtils.GetPreferenceString("glgwebnickname"));
		if (sCreator && sCreator != "")
		{
			DisableControls(true);
			
			var oRequest = new XMLHttpRequest();
			var sURL = "http://www.grocerylistgenerator.com/?page=publish";
			oRequest.open('POST', sURL, true);
			var sPostData = "recipe=" + encodeURIComponent(this.sRecipe) + "&glgdish=" + encodeURIComponent(this.sGLGDish) + "&glgitems=" + encodeURIComponent(this.sGLGItems) + "&creator=" + encodeURIComponent(sCreator) + "&userid=" + encodeURIComponent(sUserID) + "&glghtml=" + encodeURIComponent(this.sPublishRecipeHTML);
			
			oRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			oRequest.setRequestHeader("Content-length", sPostData.length);
			oRequest.oUtils = this.oUtils;
			oRequest.onreadystatechange = function ()
			{
				if (oRequest.readyState == 4)
				{
					try
					{
						if (oRequest.status == 200)
						{
							var sResponse = oRequest.responseText;
							var sResult = "-1";
							var iStart = 0, iEnd;
							iStart = sResponse.indexOf("<div id='glgpublishresult'>", 0);
							if (iStart >= 0)
							{
								iEnd = sResponse.indexOf('</div>', iStart);
								if (iEnd >= 0)
								{
									sResult = sResponse.substring(iStart + 27, iEnd);
									sResult = oRequest.oUtils.Alltrim(sResult);
								}
							}
							if (sResult == "1")
							{
								oRequest.oUtils.GLGInfo("glg-application-msg-publish-succes");
								oRequest.oUtils.SetPreferenceString("glgwebnickname", sCreator);
							}
							else
							{
								if (sResult == "-1") oRequest.oUtils.GLGInfo("glg-application-msg-publish-failed-duplicate");
								if (sResult == "-2")
								{
									oRequest.oUtils.SetPreferenceString("glgwebnickname", "");
									oRequest.oUtils.GLGInfo("glg-application-msg-publish-failed-username");
								}
							}
							try {DisableControls(false);}
							catch (e) {/*Window already closed...*/}
						}
						else
						{
							alert(oRequest.responseText);
							oRequest.oUtils.GLGInfo("glg-application-msg-publish-failed");
							try {DisableControls(false);}
							catch (e) {/*Window already closed...*/}
						}
					}
					catch (e)
					{
						alert(e);
						oRequest.oUtils.GLGInfo("glg-application-msg-publish-failed");
						try {DisableControls(false);}
						catch (e) {/*Window already closed...*/}
					}
				}
			};
			oRequest.send(sPostData);
		}
	}
}

function DisableControls(bDisable)
{
	document.getElementById('tbpublish').disabled = bDisable;
}

function PrintList()
{
	this.oPrintPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("print.");
	var sPrinter = GetPref("print_printer");
	if (sPrinter == "")
	{
		InitPrinter();
	}
	sPrinter = sPrinter.replace(/ /g, '_');
	this.oPrintPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("print.printer_" + sPrinter + ".");

	var sMarginLeft = GetPref("print_margin_left");
	var sMarginRight = GetPref("print_margin_right");

	var sFooterLeft = GetPref("print_footerleft");
	var sFooterCenter = GetPref("print_footercenter");
	var sFooterRight = GetPref("print_footerright");
	var sHeaderLeft = GetPref("print_headerleft");
	var sHeaderCenter = GetPref("print_headercenter");
	var sHeaderRight = GetPref("print_headerright");

	SetPref("print_margin_left", "0");
	SetPref("print_margin_right", "0");

	SetPref("print_footerleft", "");
	SetPref("print_footercenter", "");
	SetPref("print_footerright", "");
	SetPref("print_headerleft", "");
	SetPref("print_headercenter", "");
	SetPref("print_headerright", "");

	document.getElementById('frame_list').contentWindow.print();
	
	SetPref("print_margin_left", sMarginLeft);
	SetPref("print_margin_right", sMarginRight);

	SetPref("print_footerleft", sFooterLeft);
	SetPref("print_footercenter", sFooterCenter);
	SetPref("print_footerright", sFooterRight);
	SetPref("print_headerleft", sHeaderLeft);
	SetPref("print_headercenter", sHeaderCenter);
	SetPref("print_headerright", sHeaderRight);
	
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	oObService.notifyObservers(opener, "glg-clearrunninglist", "OK");
}

function SaveList()
{
	var oDocument = document.getElementById('frame_list').contentDocument;
	var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.download.");
	var oFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

	var sExportDir = this.oUtils.GetPreferenceString("exportdir");
	var sSaveLastDir = "";
	try
	{
		sSaveLastDir = oPrefs.getComplexValue("lastDir", Components.interfaces.nsILocalFile).path;
	}
	catch (e) {}

	oFile.initWithPath(sExportDir);
	oPrefs.setComplexValue("lastDir", Components.interfaces.nsILocalFile, oFile); //Set prefered export dir.

	saveDocument(oDocument);
	setTimeout('UpdateSaveDir(' + sSaveLastDir.toSource() + ');', 50);
	
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	oObService.notifyObservers(opener, "glg-clearrunninglist", "OK");
}

function UpdateSaveDir(sDir)
{
	if (sDir && sDir != "")
	{
		var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.download.");
		var oFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

		var sExportDir = oPrefs.getComplexValue("lastDir", Components.interfaces.nsILocalFile).path; //Might have changed.
		this.oUtils.SetPreferenceString("exportdir", sExportDir);

		oFile.initWithPath(sDir);
		oPrefs.setComplexValue("lastDir", Components.interfaces.nsILocalFile, oFile); //Set original dir back.
	}
}

function SetToolbarMode(sMode)
{
	this.oUtils.SetPreferenceString("toolbarmode", sMode);
	this.sToolbarMode = sMode;
	if (sToolbarMode == 'full')
	{
		document.getElementById('toolbar-mode-full').setAttribute('checked', true);
		document.getElementById('toolbar-mode-icons').setAttribute('checked', false);
		document.getElementById('toolbar-mode-text').setAttribute('checked', false);
	}
	if (sToolbarMode == 'icons')
	{
		document.getElementById('toolbar-mode-full').setAttribute('checked', false);
		document.getElementById('toolbar-mode-icons').setAttribute('checked', true);
		document.getElementById('toolbar-mode-text').setAttribute('checked', false);
	}
	if (sToolbarMode == 'text')
	{
		document.getElementById('toolbar-mode-full').setAttribute('checked', false);
		document.getElementById('toolbar-mode-icons').setAttribute('checked', false);
		document.getElementById('toolbar-mode-text').setAttribute('checked', true);
	}
	InitToolbar();
}

function SetToolbarIconSize(sSize)
{
	this.oUtils.SetPreferenceString("toolbariconsize", sSize);
	this.sToolbarIconSize = sSize;
	if (sSize == 'small')
	{
		document.getElementById('toolbar-iconsize-normal').setAttribute('checked', false);
		document.getElementById('toolbar-iconsize-small').setAttribute('checked', true);
	}
	else
	{
		document.getElementById('toolbar-iconsize-normal').setAttribute('checked', true);
		document.getElementById('toolbar-iconsize-small').setAttribute('checked', false);
	}
	InitToolbar();
}

function InitToolbar()
{
	var oToolbar = document.getElementById('glglist-apptoolbar');

	oToolbar.setAttribute("iconsize", this.sToolbarIconSize); //null or small
	oToolbar.setAttribute("mode", this.sToolbarMode); //full or icons or text

	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	oObService.notifyObservers(opener, "glg-updatetoolbar", "OK");
}

function Space(iLen)
{
	var sResult = "";
	var iIndex;
	for (iIndex = 0; iIndex < iLen; iIndex ++) sResult += "&nbsp;&nbsp;"
	return sResult;
}

function InitPrinter()
{
	//Copied from printUtils.js
	var lPrintSettingsAreGlobal;
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	if (pref)
	{
		lPrintSettingsAreGlobal = pref.getBoolPref("print.use_global_printsettings", false);
	}

	var printSettings;
	try
	{
		var PSSVC = Components.classes["@mozilla.org/gfx/printsettings-service;1"].getService(Components.interfaces.nsIPrintSettingsService);
		if (lPrintSettingsAreGlobal)
		{
			printSettings = PSSVC.globalPrintSettings;
		}
		else
		{
			printSettings = PSSVC.newPrintSettings;
		}
	} catch (e) {dump("getPrintSettings: "+e+"\n");}
	return printSettings;
}

function GetPref(sName)
{
	var sPref = "";
	try
	{
		try {sPref = this.oPrintPref.getComplexValue(sName, Components.interfaces.nsIPrefLocalizedString).data;}
		catch (e) {sPref = "";}
		sPref = this.oPrintPref.getCharPref(sName);
	}
	catch (e) {sPref = "";}
	return sPref;
}

function SetPref(sName, sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oPrintPref.setComplexValue(sName, Components.interfaces.nsIPrefLocalizedString, oPLS);
}

